并查集压缩hdu2818

#include<cstdio>
#include<algorithm>
using namespace std;
int root[30010];
int num1[30010];
int num2[30010];
int find2(int x)
{
    if(x != root[x])
    {
        int fx  = root[x];
        root[x]  = find2(fx);
        num1[x] +=  num1[fx];
    }
    return root[x];
}
void Union(int a,int b)
{
    int fa = find2(a);
    int fb = find2(b);
    if(fa != fb)
    {
        root[fa] = fb;
        num1[fa] = num2[fb] + 1;
        num2[fb] += num2[fa] + 1;
    }
}
int main()
{
    for(int i=1;i<=30000;i++) root[i]=i;
    int p;
    scanf("%d",&p);
    while(p--)
    {
        char c;
        scanf("%*c%c",&c);
        if(c == 'M'){
            int a,b;
        scanf("%d%d",&a,&b);
            Union(a,b);
        }
        else {
            int d;
        scanf("%d",&d);
            find2(d);
            printf("%d\n",num1[d]);

//        for(int i=1;i<=10;i++)
//            printf("%d ",num1[i]); printf("\n");
        }
    }
    return 0;
}

开了3个数组,要仔细想

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-09 04:56:27

并查集压缩hdu2818的相关文章

并查集压缩路径

普通的并查集是这样婶的 void find1(int x) { int t=x; while(pre[t]!=t) { t=pre[t]; } } 如果复杂度比较高的话可以使用路径压缩(非递归版好理解,且不易爆栈),是这样婶的 void find1(int x) { int t=x; while(pre[t]!=t) { t=pre[t];//此时t就是最终的祖先 } int k=x;//k是最开始的那个点 while(t!=k) { int m=pre[k];//先保存一下结点的直接祖先: p

poj1456Supermarket——并查集压缩查找

题目:http://poj.org/problem?id=1456 排序+贪心,每次选利润最大的,放在可能的最靠后的日期卖出,利用并查集快速找到下一个符合的日期. 代码如下: #include<iostream> #include<cstdio> #include<cstring> using namespace std; int n,t,ans,fa[10005]; struct N{ int p,d; }a[10005],hp[10005]; int find(in

最小生成树个数 并查集压缩路径

1016: [JSOI2008]最小生成树计数 Time Limit: 1 Sec  Memory Limit: 162 MBSubmit: 5843  Solved: 2379[Submit][Status][Discuss] Description 现在给出了一个简单无向加权图.你不满足于求出这个图的最小生成树,而希望知道这个图中有多少个不同的 最小生成树.(如果两颗最小生成树中至少有一条边不同,则这两个最小生成树就是不同的).由于不同的最小生 成树可能很多,所以你只需要输出方案数对3101

并查集 压缩路径

int find(int x) { int k, j, r; r = x; while(r != parent[r]) //查找跟节点 r = parent[r]; //找到跟节点,用r记录下 k = x; while(k != r) //非递归路径压缩操作 { j = parent[k]; //用j暂存parent[k]的父节点 parent[k] = r; //parent[x]指向跟节点 k = j; //k移到父节点 } return r; //返回根节点的值 } void combin

Codeforces 827D Best Edge Weight 倍增 + 并查集 || 倍增 + 压倍增标记 (看题解)

Best Edge Weight 我们先找出一棵最小生成树, 对于非树边来说, 答案就是两点路径上的最大值 - 1, 这个直接倍增就能处理. 对于树边来说, 就是非树边的路径经过这条边的最小值 - 1, 这个可以用并查集压缩路径 或者 更压st表一样的方式更新. 感觉就是没想到先扣出来一个最小生成树, 而是往克鲁斯卡尔的过程中想了. #include<bits/stdc++.h> #define LL long long #define LD long double #define ull u

并查集 路径压缩

使用并查集查找时,如果查找次数很多,那么使用朴素版的查找方式肯定要超时.比如,有一百万个元素,每次都从第一百万个开始找,这样一次运算就是10^6,如果程序要求查找个一千万次,这样下来就是10^13,肯定要出问题的. 这是朴素查找的代码,适合数据量不大的情况: int findx(int x){ int r=x; while(parent[r] !=r) r=parent[r]; return r;} 下面是采用路径压缩的方法查找元素: int find(int x) //查找x元素所在的集合,回

poj 2513 Colored Sticks(欧拉回路 并查集 路径压缩 字典树)(困难)

Colored Sticks Time Limit: 5000MS   Memory Limit: 128000K Total Submissions: 32545   Accepted: 8585 Description You are given a bunch of wooden sticks. Each endpoint of each stick is colored with some color. Is it possible to align the sticks in a st

hdu 1558 线段相交+并查集路径压缩

Segment set Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 3457    Accepted Submission(s): 1290 Problem Description A segment and all segments which are connected with it compose a segment set.

并查集(2)-按秩合并和路径压缩

在上面一讲是并查集(1)-判断无向图是否存在环. 我们使用了并查集的两个操作: union() 和 find() // find 的原始实现 int find(int parent[], int i) { if (parent[i] == -1) return i; return find(parent, parent[i]); } // union()的原始实现 void Union(int parent[], int x, int y) { int xset = find(parent, x